#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <memory.h>
#include <malloc.h>
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include     <sys/types.h>  /**/
#include     <sys/stat.h>   /**/
#include     <fcntl.h>      /*ļƶ*/
#include     <termios.h>    /*PPSIXն˿ƶ*/
#include     <errno.h>      /*Ŷ*/
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>

#include <iconv.h>
#include <sys/stat.h>
#include <locale.h>

int code_convert(char *from_charset, char *to_charset, char *inbuf, size_t inlen, char *outbuf, size_t outlen) {

	iconv_t cd;
	char **pin = &inbuf;
	char **pout = &outbuf;


	cd = iconv_open(to_charset, from_charset);
	if (cd == 0)
		return -1;

	memset(outbuf, 0, outlen);
	if (iconv(cd, pin, &inlen, pout, &outlen) == -1)
		return -1;

	iconv_close(cd);
	*pout = '\0';


	return 0;
}


int u2g(char *inbuf, size_t inlen, char *outbuf, size_t outlen) {
	return code_convert("utf-8", "gbk", inbuf, inlen, outbuf, outlen);
}


int g2u(char *inbuf, size_t inlen, char *outbuf, size_t outlen) {
	return code_convert("gbk", "utf-8", inbuf, inlen, outbuf, outlen);
}

int InitComm(const char* szPort);//ʼ豸
int FindCardCmd();//ҿ
int SelCardCmd();//ѡ
int ReadCardId(char szID[8]);//id
int ReadCard(char* szTxt, char* szWlt, char* szBmp);//ͨ
int ReadCardExt(char* szTxt, char* szWlt, char* szBmp);//ָƿ
int WltToBmp(char* szWlt, char* szBmp);//Ƭ
int GetFingerData(char* szFingerData);
void WriteLog(char* szFile, char *Msg, int iLen);
void print_buf(unsigned char *buf, int size);

int FindSelCard()
{
	int iRet = FindCardCmd();

	if (iRet != 0x9f && iRet != 0x80){//0x80δſ߿Ѿ0x9fֻڵһζʱ
		printf("FindCardCmd error\n");
		CloseComm();
		return 0;
	}

	iRet = SelCardCmd();
	if (iRet != 0x90 && iRet != 0x81){//0x81δſ߿Ѿ0x90ֻڵһζʱ
		printf("SelCardCmd error\n");
		CloseComm();
		return 0;
	}

	return 1;
}

int ToInt(char* s)
{
	int iRet = -1;
	int iLen;
	int i;
	iLen = strlen(s);
	if (iLen == 0)
		return iRet;

	for (i=0; i<iLen; i++)
		if (!isdigit(s[i]))
			return iRet;

	iRet = atoi(s);
	return iRet;
}

int Read1()
{

	char szTxt[500] = {0};
	char szWlt[2048] = {0};
	char szBmp[38862] = {0};
	char szBmp1[38862+1024] = {0};


	if (ReadCard(szTxt, szWlt, szBmp) != 1){
		printf("ReadCard error\n");
		return 0;
	}

	char szTmp[512] = {0};

	int iLen = g2u(szTxt, strlen(szTxt), szTmp, 512);
	printf("card data:%s\n", szTmp);

	WriteLog("wz.txt", szTxt, strlen(szTxt));//źҶ|Ů||19881118|ӱʡسƹƹ帴·25|130423198811184328|ع|20110330-20210330
	WriteLog("zp.wlt", szWlt, 1024);
	WriteLog("zp1.wlt", szWlt+1024, 1024);
	WriteLog("zp.bmp", szBmp, 38862);

	if (!WltToBmp(szWlt, szBmp1)){//szBmp1ǰ38862ΪƬBMP,1024ΪԭʼWLT
		printf("\r\nWltToBmp error\r\n");
		return 0;
	}

	WriteLog("zp1.bmp", szBmp1, 38862);//szBmp1ǰ38862ΪƬBMP
	WriteLog("zp2.wlt", szBmp1+38862, 1024);
	printf("txt is: %s\n", szTxt);

	return 1;
}


int Read2()
{
	char szTxt[500] = {0};
	char szWlt[2048] = {0};
	char szBmp[38862] = {0};
	char szBmp1[38862+1024] = {0};
	char szFinger[1024] = {0};
	int iFingerLen = 0;

	if (ReadCardExt(szTxt, szWlt, szBmp) != 1){
		printf("ReadCard error\n");
		return 0;
	}

	{
		printf("ReadAppCmd Result is [%d]\n", ReadAppCmd());
	}

	WriteLog("wz.txt", szTxt, strlen(szTxt));//źҶ|Ů||19881118|ӱʡسƹƹ帴·25|130423198811184328|ع|20110330-20210330
	WriteLog("zp.wlt", szWlt, 1024);
	WriteLog("zp1.wlt", szWlt+1024, 1024);
	WriteLog("zp.bmp", szBmp, 38862);
	iFingerLen = GetFingerData(szFinger);
	WriteLog("finger.bin", szFinger, iFingerLen);

	if (!WltToBmp(szWlt, szBmp1)){//szBmp1ǰ38862ΪƬBMP,1024ΪԭʼWLT
		printf("\r\nWltToBmp error\r\n");
		return 0;
	}

	WriteLog("zp1.bmp", szBmp1, 38862);//szBmp1ǰ38862ΪƬBMP
	WriteLog("zp2.wlt", szBmp1+38862, 1024);
	printf("txt is: %s\n", szTxt);
	return 1;
}

int main(int argc, char* argv[])
{
	int iCard = 1;
	int iRet = 0;
	char szTmp[50] = {0};

	if (argc >= 2){
		iRet = InitComm(argv[1]);
	}else{
		iRet = InitComm("/dev/ttyS1");
		//iRet = InitComm1("/dev/ttyMT1");
	}

	if (iRet != 1){
		printf("InitComm error:%d\n", iRet);
		CloseComm();
		return 0;
	}

	if (argc >= 3){
		iCard = ToInt(argv[2]);
	}

	iRet = ReadCardId(szTmp);
	if (iRet == 144){
		printf("\r\nReadCardId: ");
		print_buf(szTmp, 8);
		printf("\r\n");
	}else{
		printf("\r\nReadCardId error\r\n");
	}

	if (FindSelCard() != 1){
		printf("\r\nFindAndSelCard error\r\n");
		return 0;
	}

	if (iCard == 1){
		Read1();
		printf("\r\nRead card over\r\n");
	}else{
		Read2();
		printf("\r\nRead finger card over\r\n");
	}

	return 0;
}

//cp -f libtermb.so /usr/lib/libtermb.so
//gcc -o t t.c -L./ -ltermb
//arm-linux-gcc -o t t.c -L./ -ltermb
